require File.expand_path(File.dirname(__FILE__) + '/spec_helper')

describe Emvoicer::Client do
  context "in general" do
    let(:service) do
      Emvoicer::Services::Base.new
    end

    let(:client) do
      attributes = {
        :id => 1,
        :name => "Haute Haute Heat",
        :address_1 => "1234 Main Street",
        :address_2 => "Suite 123",
        :city => "Anytown",
        :zip_code => "70123",
        :country => "US",
        :phone => "123-555-1212"
      }

      Emvoicer::Client.new(service, attributes)
    end

    describe ".service" do
      it "returns service which client was created with" do
        client.service.should eq(service)
      end
    end

    [
      :id,
      :name,
      :address_1,
      :address_2,
      :city,
      :zip_code,
      :country,
      :phone
    ].each do |attr|
      describe ".#{ attr }" do
        it "returns value of #{ attr } attribute" do
          client.send(attr).should eq(client.attributes[attr])
        end
      end
    end
  end
end
