require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')

describe Emvoicer::Services::HttpAuth do
  let(:service) do
    Emvoicer::Services::HttpAuth.new
  end

  describe ".request_headers" do
    it "it returns headers with authorization credentials" do
      service.stubs(:headers).returns({ "Accept" => "application/xml" })
      service.stubs(:auth_params).returns(["username", "password"])

      service.request_headers.should eq({
        "Accept" => "application/xml",
        "Authorization" => ["username", "password"]
      })
    end
  end

  describe ".authentication_valid?" do
    let(:response) { "Response" }

    it "passess invoices response to service test_authentication_response method" do
      service.stubs(:invoices_url).returns("http://example.com/invoices")
      service.stubs(:auth_params).returns(["user", "pass"])
      stub_request(:get, "http://user:pass@example.com/invoices").
        with(:headers => {"Accept"=>"*/*", "User-Agent"=>"Ruby"}).
        to_return(:status => 200, :body => "", :headers => {})

      service.class.expects(:test_authentication_response)
      service.authentication_valid?
    end
  end
end
